
function love.load()

	require("Vector")
	require("camera")
	require("sceneObjects")
	--require("Loveframes")
	require("gameObject")
	require("mainCharacter")

	sqrt2 = math.sqrt(2)

	love.graphics.setBackgroundColor(255,255,255)

	mainCharacter = mainCharacter.new(Vector.new(1000,1000), "Images/testimage2.png")
	sceneObjects:addToScene(mainCharacter)
	camera:move(mainCharacter.position.x,mainCharacter.position.y)
	
	someObject = gameObject.new(Vector.new(1500,1000), Vector.new(0,0), 0, false, true, "Images/testimage2.png")
	sceneObjects:addToScene(someObject)
	someObject2 = gameObject.new(Vector.new(1500,1500), Vector.new(0,0), 0, false, true, "Images/testimage2.png")
	sceneObjects:addToScene(someObject2)

	wall  = gameObject.new(Vector.new(2000,1000), Vector.new(0,0), 0, false, true, "Images/wall.png")
	sceneObjects:addToScene(wall)
	--colorCanvas = love.graphics.newCanvas()


	grass = {}
    dirt = {}
    grass.image = love.graphics.newImage("Images/grass2.png")
    dirt.image = love.graphics.newImage("Images/dirt2.png")
    block_width = 100
    block_height = 100
    block_depth = block_height
    grid_x = 0
    grid_y = 0

    --world creation
    grid_size = 40
    grid = {}
    for x = 1,grid_size do
       grid[x] = {}
       for y = 1,grid_size do
            if x%5 == 0 or y%5 == 0 then
                grid[x][y] = 2
            else
                grid[x][y] = 1
            end
       end
    end



canvas = love.graphics.newCanvas(5000,5000)
love.graphics.setCanvas(canvas)
	for x = 1,grid_size do
		for y = 1,grid_size do
			if grid[x][y] == 1 then
				love.graphics.draw(grass.image,
				 (((y/sqrt2)+(x/sqrt2)) * 40 )  ,
				 (((y/sqrt2)-(x/sqrt2)) * 30   + 1500) )
			else -- grid[x][y] == 2
				love.graphics.draw(dirt.image,
				 (((y/sqrt2)+(x/sqrt2)) * 40 )  ,
				 (((y/sqrt2)-(x/sqrt2)) * 30   + 1500) )
			end
		end
	end
	
love.graphics.setCanvas()


end




function love.draw()
	
	camera:set()
	for x = 1,grid_size do
		for y = 1,grid_size do
			if grid[x][y] == 1 then
				love.graphics.draw(grass.image,
				 math.floor((((y/sqrt2)+(x/sqrt2)) * 66 ))  ,
				 math.floor((((y/sqrt2)-(x/sqrt2)) * 43.56 )  + 1500) )
			else -- grid[x][y] == 2
				love.graphics.draw(dirt.image,
				 math.floor((((y/sqrt2)+(x/sqrt2)) * 66 ))  ,
				 math.floor((((y/sqrt2)-(x/sqrt2)) * 43.56 )  + 1500) )
			end
		end
	end

	sceneObjects:draw()
	camera:unset()
end


function love.update(dt)
	sceneObjects:update(dt)
end

function love.keypressed(key)

end

function love.mousepressed(x,y,button)
	--[[love.graphics.setCanvas(canvas)

	r,g,b,a = canvas:getPixel(camera.position.x + x - love.graphics.getWidth()/2, 
		camera.position.y + y - love.graphics.getHeight()/2)
	print("Color at pixel " .. math.floor(camera.position.x) .."," .. math.floor(camera.position.y) .. " is " .. r .. "  " .. g .. "  " .. b .. "  " .. a)
	love.graphics.setCanvas()--]]
end

function screenToWorldCoordinaties(x,y)
	local screenx = x
	local screeny = y


end