sceneObjects = {}
sceneObjects.__index = sceneObjects

sceneObjects.size = 0
sceneObjects.drawOrder = {}



--adds the object to the current scene
function sceneObjects:addToScene(newObject)

	sceneObjects.size = sceneObjects.size + 1
	sceneObjects[sceneObjects.size] = newObject
	if(sceneObjects.size > 1) then
		sceneObjects.drawOrder[sceneObjects.size] = newObject
		for x = sceneObjects.size, 2, -1 do
			if sceneObjects.drawOrder[x].position.y > sceneObjects.drawOrder[x-1].position.y then
				return
			else
				local temp = sceneObjects.drawOrder[x-1]
				sceneObjects.drawOrder[x-1] = sceneObjects.drawOrder[x]
				sceneObjects.drawOrder[x] = temp
			end
		end
	else
		sceneObjects.drawOrder[1] = newObject
	end
end

--returns the number of objects in the scene
function sceneObjects:getSize()
	return sceneObjects.size
end

--returns the object at the indicated index
function sceneObjects:getObject(num)
	return sceneObjects[x]
end

--draws every object to the scene
function sceneObjects:draw()
	for x = 1, sceneObjects.size do
		sceneObjects.drawOrder[x]:draw()
	end
end

--removes the object from the scene
function sceneObjects:removeFromScene(objectToRemove)
	for x = 1, sceneObjects.size do
		if sceneObjects[x] == objectToRemove then
			for y = x, sceneObjects.size do
				sceneObjects[y] = sceneObjects[y+1]
			end
			sceneObjects.size = sceneObjects.size -1
			return
		end
	end
end


function sceneObjects:update(dt)
	for x = 1, sceneObjects.size do
		sceneObjects[x]:update(dt)
	end
end

local function giveObjectKeyColor()
	sceneObjects[sceneObjects.size].keyColor = sceneObjects.size 
end